Public Class Form1

    Const MaxAns As Integer = 3
    Const MaxHistX As Integer = MaxAns
    Const MaxHistY As Integer = 3
    Const MaxInp As Integer = 9

    Const PosAnsX As Integer = 12
    Const PosAnsY As Integer = 8
    Const PosInpS As Integer = 8
    Const PosInpL As Integer = 240

    Private sizeBox As Integer = 32
    Private sizeTextX As Integer = 40
    Private sizeTextY As Integer = 14
    Private sizeDigitX As Integer = 8
    Private sizeDigitY As Integer = 14

    Private pctAns(MaxAns) As PictureBox
    Private pctHist(MaxHistX * MaxHistY - 1) As PictureBox
    Private pctInput(MaxInp) As PictureBox
    Private pctOrg(MaxInp) As PictureBox

    Private pctHitT(MaxHistY) As PictureBox
    Private pctHitN3(MaxHistY) As PictureBox
    Private pctBlowT(MaxHistY) As PictureBox
    Private pctBlowN3(MaxHistY) As PictureBox

    Private pctNum(9) As PictureBox

    Private ansAns(MaxAns) As Integer
    Private inpAns(MaxAns) As Integer
    Private inpInput(MaxInp) As Integer
    Private inpCount As Integer

    Private totalCount As ClsScore
    Private ansHit As ClsScore
    Private ansBlow As ClsScore

    Private csrSelect As Cursor

    Dim rnd As Random

    Private frmWidth As Integer = 0
    Private frmHeight As Integer = 0

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        totalCount = New ClsScore
        ansHit = New ClsScore
        ansBlow = New ClsScore

        frmWidth = Me.Size.Width
        frmHeight = Me.Size.Height
        sizeBox = Me.pctNum00.Width

        rnd = New Random

        Dim i As Integer
        pctAns = New System.Windows.Forms.PictureBox() { _
            Me.pctAns1, Me.pctAns2, Me.pctAns3, Me.pctAns4 _
        }
        For i = 0 To pctAns.Length - 1
            pctAns(i).Tag = i
        Next i
        pctHist = New System.Windows.Forms.PictureBox() { _
            Me.pctHis01, Me.pctHis02, Me.pctHis03, Me.pctHis04, _
            Me.pctHis05, Me.pctHis06, Me.pctHis07, Me.pctHis08, _
            Me.pctHis09, Me.pctHis10, Me.pctHis11, Me.pctHis12, _
            Me.pctHis13, Me.pctHis14, Me.pctHis15, Me.pctHis16 _
        }
        For i = 0 To pctHist.Length - 1
            pctHist(i).Tag = i
        Next i
        pctInput = New System.Windows.Forms.PictureBox() { _
            Me.pctNum00, Me.pctNum01, Me.pctNum02, Me.pctNum03, Me.pctNum04, _
            Me.pctNum05, Me.pctNum06, Me.pctNum07, Me.pctNum08, Me.pctNum09 _
        }
        For i = 0 To pctInput.Length - 1
            Me.pctInput(i).Tag = i
        Next i
        pctOrg = New System.Windows.Forms.PictureBox() { _
            Me.pctOrg00, Me.pctOrg01, Me.pctOrg02, Me.pctOrg03, Me.pctOrg04, _
            Me.pctOrg05, Me.pctOrg06, Me.pctOrg07, Me.pctOrg08, Me.pctOrg09, _
            Me.pctOrgClr _
        }
        pctHitT = New System.Windows.Forms.PictureBox() { _
            Me.pctHit1, Me.pctHit2, Me.pctHit3, Me.pctHit4 _
        }
        pctHitN3 = New System.Windows.Forms.PictureBox() { _
            Me.pctDig113, Me.pctDig213, Me.pctDig313, Me.pctDig413 _
        }
        pctBlowT = New System.Windows.Forms.PictureBox() { _
            Me.pctBlow1, Me.pctBlow2, Me.pctBlow3, Me.pctBlow4 _
        }
        pctBlowN3 = New System.Windows.Forms.PictureBox() { _
            Me.pctDig123, Me.pctDig223, Me.pctDig323, Me.pctDig423 _
        }
        pctNum = New System.Windows.Forms.PictureBox() { _
            Me.pctNum0, Me.pctNum1, Me.pctNum2, Me.pctNum3, pctNum4, _
            Me.pctNum5, Me.pctNum6, Me.pctNum7, Me.pctNum8, pctNum9 _
        }

        csrSelect = New Cursor(0, MaxInp)
        Me.ResizeForm()

        makeAns()
        ClearScreen()

        Dim csr As Integer = csrSelect.Pos
        pctCursor.Location = New System.Drawing.Point( _
                                pctInput(csr).Location.X - 4, _
                                pctInput(csr).Location.Y - 4)
        pctCursor.Image = pctInput(csr).Image

    End Sub

    Private Sub ResizeForm()
        If frmWidth = 0 Then Exit Sub

        Dim type As Integer
        Dim posX As Integer
        Dim posY As Integer
        Dim posLeft As Integer
        Dim posTop As Integer
        'Dim h As Integer = Me.Height
        'Dim w As Integer = Me.Width
        Dim h As Integer = System.Windows.Forms.Screen.PrimaryScreen.Bounds.Height
        Dim w As Integer = System.Windows.Forms.Screen.PrimaryScreen.Bounds.Width
        Dim zoom As Integer
        'w = 480
        If w <= 240 Then
            w = 240
            h = 320
            zoom = 1
            sizeBox = 32
            type = 0
            posX = (w - sizeBox * (MaxInp / 2 + 1)) / 2
            posY = PosInpL - 64
            posLeft = PosAnsX
            posTop = PosAnsY
        ElseIf w <= 320 Then
            w = 320
            h = 240
            zoom = 1
            sizeBox = 32
            type = 1
            posX = PosInpL
            posY = PosInpS
            posLeft = PosAnsX
            posTop = PosAnsY
        ElseIf w <= 480 Then
            w = 480
            h = 640
            zoom = 2
            sizeBox = 64
            type = 0
            posX = (PosInpS + 16) * 2
            posY = (PosInpL - 64) * 2
            posLeft = PosAnsX * 2
            posTop = PosAnsY * 2
        Else
            w = 640
            h = 480
            zoom = 2
            sizeBox = 64
            type = 1
            posX = PosInpL * 2
            posY = PosInpS * 2
            posLeft = PosAnsX * 2
            posTop = PosAnsY * 2
        End If
        Me.Height = h
        Me.Width = w

        If frmWidth = w And frmHeight = h Then Exit Sub

        frmWidth = Me.Width
        frmHeight = Me.Height

        Dim i As Integer
        For i = 0 To pctAns.Length - 1
            pctAns(i).Width = sizeBox
            pctAns(i).Height = sizeBox
            pctAns(i).Location = New System.Drawing.Point( _
                            posLeft + i * sizeBox, _
                            posTop)
        Next i

        Dim x As Integer = posLeft
        Dim y As Integer = posTop + sizeBox + sizeBox * 1 / 16
        For i = 0 To pctHist.Length - 1
            pctHist(i).Width = sizeBox
            pctHist(i).Height = sizeBox
            pctHist(i).Location = New System.Drawing.Point(x, y)
            x += sizeBox
            If i Mod pctAns.Length = pctAns.Length - 1 Then
                x = posLeft
                y += sizeBox
            End If
        Next i

        h = sizeBox / 2
        x = posLeft + sizeBox * pctAns.Length + 4
        y = posTop + (sizeBox - sizeTextY) / 2
        pctCount.Width = sizeTextX * zoom
        pctCount.Height = sizeTextY * zoom
        pctCount.Location = New System.Drawing.Point(x, y)
        x += pctCount.Width
        x += sizeDigitX * zoom
        pctDig002.Width = sizeDigitX * zoom
        pctDig002.Height = sizeDigitY * zoom
        pctDig002.Location = New System.Drawing.Point(x, y)
        x += pctDig002.Width
        pctDig003.Width = pctDig002.Width
        pctDig003.Height = pctDig002.Height
        pctDig003.Location = New System.Drawing.Point(x, y)

        y = pctHist(0).Location.Y
        For i = 0 To pctHitT.Length - 1
            pctHitT(i).Width = sizeTextX * zoom
            pctHitT(i).Height = sizeTextY * zoom
            pctHitT(i).Location = New System.Drawing.Point( _
                            pctCount.Location.X, y)
            pctHitN3(i).Width = sizeDigitX * zoom
            pctHitN3(i).Height = sizeDigitY * zoom
            pctHitN3(i).Location = New System.Drawing.Point( _
                            pctDig003.Location.X, y)
            y += h
            pctBlowT(i).Width = sizeTextX * zoom
            pctBlowT(i).Height = sizeTextY * zoom
            pctBlowT(i).Location = New System.Drawing.Point( _
                            pctCount.Location.X, y)
            pctBlowN3(i).Width = pctDig003.Width
            pctBlowN3(i).Height = pctDig003.Height
            pctBlowN3(i).Location = New System.Drawing.Point( _
                            pctDig003.Location.X, y)
            y += h
        Next i

        Dim lap As Integer = pctInput.Length / 2 - 1
        If type = 0 Then
            x = posX
            y = posY
            For i = 0 To pctInput.Length - 1
                pctInput(i).Width = sizeBox
                pctInput(i).Height = sizeBox
                pctInput(i).Location = New System.Drawing.Point(x, y)
                x += sizeBox
                If i = lap Then
                    x = posX
                    y += sizeBox
                End If
            Next i
        Else
            x = posX
            y = posY
            For i = 0 To pctInput.Length - 1
                pctInput(i).Width = sizeBox
                pctInput(i).Height = sizeBox
                pctInput(i).Location = New System.Drawing.Point(x, y)
                y += sizeBox
                If i = lap Then
                    y = posY
                    x += sizeBox
                End If
            Next i
        End If
        pctCursor.Width = sizeBox + sizeBox * 1 / 4
        pctCursor.Height = sizeBox + sizeBox * 1 / 4
        csrSelect.Shift = CInt((pctCursor.Width - pctInput(0).Width) / 2)
        SetCursor()

    End Sub

    Private Sub Form1_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown
        Dim csrOld As Integer = csrSelect.Pos
        Select Case e.KeyCode
            Case Keys.Up, Keys.Left
                csrSelect.Up()
            Case Keys.Down, Keys.Right
                csrSelect.Down()
            Case Keys.Enter
                SelectNumber(csrSelect.Pos)
                SetCursor()
                Exit Sub
            Case Else
                'nop
        End Select
        Dim csrNew As Integer = csrSelect.Pos
        If csrOld <> csrNew Then
            SetCursor()
        End If
    End Sub

    Private Sub SetCursor()
        Dim csr As Integer = csrSelect.Pos
        Dim sft As Integer = csrSelect.Shift
        pctCursor.Location = New System.Drawing.Point( _
                        pctInput(csr).Location.X - sft, _
                        pctInput(csr).Location.Y - sft)
        pctCursor.Image = pctInput(csr).Image
    End Sub

    Private Sub pctCursor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pctCursor.Click
        SelectNumber(csrSelect.Pos)
        SetCursor()
    End Sub

    Private Sub pctInputBox_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _
            pctNum00.Click, pctNum01.Click, pctNum02.Click, pctNum03.Click, pctNum04.Click, _
            pctNum05.Click, pctNum06.Click, pctNum07.Click, pctNum08.Click, pctNum09.Click
        Dim pct As PictureBox = sender
        Dim no As Integer = pct.Tag
        csrSelect.Pos = no
        SetCursor()
    End Sub

    Private Sub SelectNumber(ByVal no As Integer)
        If no = 0 Then
            ClearAns()
            inpCount = 0
            Exit Sub
        End If
        If inpInput(no) < 0 Then Exit Sub

        inpAns(inpCount) = no
        pctAns(inpCount).Image = pctInput(no).Image
        pctInput(no).Image = pctOrgClr.Image
        inpInput(no) = -1
        inpCount += 1
        If inpCount = MaxAns + 1 Then
            Dim res As Boolean = Me.CheckAns()
            If res Then
                totalCount.Num += 1
                MsgBox(totalCount.Num.ToString & "Ő", MsgBoxStyle.OkOnly)
                makeAns()
                ClearScreen()
                Exit Sub
            End If
            Me.CopyHistory()
            inpCount = 0
        End If
    End Sub

    Private Function Rand1(ByVal max As Integer) As Integer
        Return rnd.Next(max)
    End Function

    Private Sub makeAns()
        Dim num(MaxInp) As Integer
        Dim i As Integer
        Dim r As Integer
        For i = 1 To MaxInp
            num(i) = i
        Next i
        For i = 0 To MaxInp
            r = Rand1(MaxInp - 1) + 1
            If i <> r Then
                num(0) = num(i)
                num(i) = num(r)
                num(r) = num(0)
            End If
        Next i
        num(0) = 0
        For i = 0 To ansAns.Length - 1
            ansAns(i) = num(i + 1)
        Next i
        'Dim s As String = ansAns(0).ToString + ansAns(1).ToString + ansAns(2).ToString + ansAns(3).ToString
        'MsgBox(s)
    End Sub

    Private Sub ClearAns()
        Dim i As Integer
        For i = 0 To MaxAns
            pctAns(i).Image = pctOrgClr.Image
            inpAns(i) = -1
        Next i
        For i = 0 To MaxInp
            Me.pctInput(i).Image = pctOrg(i).Image
            inpInput(i) = i
        Next i
        inpCount = 0
    End Sub

    Private Sub ClearScreen()
        ansHit.Num = 0
        ansBlow.Num = 0
        totalCount.Num = 0
        DispCount()
        ClearAns()
        For i As Integer = 0 To Me.pctHist.Length - 1
            Me.pctHist(i).Image = pctOrgClr.Image
        Next i
        For i As Integer = 0 To Me.pctHitN3.Length - 1
            DispHit(i)
            DispBlow(i)
        Next i
    End Sub

    Private Sub CopyHistory()
        Dim width As Integer = MaxHistX + 1
        For y As Integer = MaxHistY To 1 Step -1
            For x As Integer = 0 To MaxHistX
                Me.pctHist(y * width + x).Image = _
                            Me.pctHist((y - 1) * width + x).Image
            Next x
            Me.pctHitN3(y).Image = Me.pctHitN3(y - 1).Image
            Me.pctBlowN3(y).Image = Me.pctBlowN3(y - 1).Image
        Next y
        For x As Integer = 0 To MaxAns
            Me.pctHist(x).Image = Me.pctAns(x).Image
        Next x
        totalCount.Num += 1
        DispCount()
        DispHit(0)
        DispBlow(0)
        ClearAns()
    End Sub

    Private Function CheckAns() As Boolean
        Dim cntHit As Integer = 0
        Dim cntBlw As Integer = 0
        For y As Integer = 0 To inpAns.Length - 1
            For x As Integer = 0 To inpAns.Length - 1
                If inpAns(y) = ansAns(x) Then
                    If x = y Then
                        cntHit += 1
                    Else
                        cntBlw += 1
                    End If
                End If
            Next x
        Next y
        ansHit.Num = cntHit
        ansBlow.Num = cntBlw
        If cntHit = MaxAns + 1 Then
            Return True
        End If
        Return False
    End Function

    Private Sub mnuExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuExit.Click
        Me.Close()
    End Sub

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        ResizeForm()
    End Sub

    Private Sub DispCount()
        Dim dig() As Integer = totalCount.Digit()
        'MsgBox(totalCount.Num.ToString & " " & totalCount.Digit(2))
        pctDig002.Image = pctNum(dig(1)).Image
        pctDig003.Image = pctNum(dig(2)).Image
    End Sub

    Private Sub DispHit(ByVal pos As Integer)
        Dim dig() As Integer = ansHit.Digit()
        pctHitN3(pos).Image = pctNum(dig(2)).Image
    End Sub

    Private Sub DispBlow(ByVal pos As Integer)
        Dim dig() As Integer = ansBlow.Digit()
        pctBlowN3(pos).Image = pctNum(dig(2)).Image
    End Sub

End Class

Class Cursor
    Private m_posMin As Integer = 0
    Property PosMin()
        Get
            Return m_posMin
        End Get
        Set(ByVal value)
            m_posMin = value
        End Set
    End Property

    Private m_posMax As Integer = 9
    Property PosMax()
        Get
            Return m_posMax
        End Get
        Set(ByVal value)
            m_posMax = value
        End Set
    End Property

    Private m_width As Integer
    Property Width() As Integer
        Get
            Return m_width
        End Get
        Set(ByVal value As Integer)
            m_width = value
        End Set
    End Property

    Private m_height As Integer
    Property Height() As Integer
        Get
            Return m_height
        End Get
        Set(ByVal value As Integer)
            m_height = value
        End Set
    End Property

    Private m_shift As Integer
    Property Shift() As Integer
        Get
            Return m_shift
        End Get
        Set(ByVal value As Integer)
            m_shift = value
        End Set
    End Property

    Private m_pos As Integer
    Property Pos() As Integer
        Get
            Return m_pos
        End Get
        Set(ByVal value As Integer)
            If value >= PosMin And value <= PosMax + 1 Then
                m_pos = value
            End If
        End Set
    End Property

    Public Sub SetMin()
        Me.Pos = PosMin
    End Sub

    Public Sub SetMax()
        Me.Pos = PosMax
    End Sub

    Public Sub Up()
        If Me.Pos > PosMin Then
            Me.Pos -= 1
        End If
    End Sub

    Public Sub Down()
        If Me.Pos < PosMax Then
            Me.Pos += 1
        End If
    End Sub

    Public Sub New(ByVal min As Integer, ByVal max As Integer)
        Me.PosMin = min
        Me.PosMax = max
        Me.SetMin()
    End Sub

End Class
